# Request termination

POST https://api.letsdeel.com/rest/v2/gp/workers/{worker_id}/terminations
Content-Type: application/json

Request a termination for a global payroll employee. A successful call starts the termination process and does not confirm termination.
 **Token scopes**: `global-payroll:write`

Reference: https://developer.deel.com/api/endpoints/gp-hiring/create-gp-worker-termination

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /gp/workers/{worker_id}/terminations:
    post:
      operationId: create-gp-worker-termination
      summary: Request termination
      description: >-
        Request a termination for a global payroll employee. A successful call
        starts the termination process and does not confirm termination.
         **Token scopes**: `global-payroll:write`
      tags:
        - subpackage_gpHiring
      parameters:
        - name: worker_id
          in: path
          description: Unique identifier for a worker in UUID format.
          required: true
          schema:
            type: string
            format: uuid
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/gp-hiring_createGPWorkerTermination_Response_201
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        description: Request body to request a termination for an employee.
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaData
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf0Type:
      type: string
      enum:
        - TIME
      description: The type of severance, either in time off.
      title: >-
        GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf0Type
    GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf0TimeUnit:
      type: string
      enum:
        - DAYS
        - WEEKS
        - MONTHS
      description: The unit of time for severance (e.g., DAYS, WEEKS, MONTHS).
      title: >-
        GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf0TimeUnit
    GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf0Type
          description: The type of severance, either in time off.
        amount:
          type: number
          format: double
          description: >-
            The amount of severance, specified in the designated currency or
            time unit.
        currency:
          type: string
          description: Currency code for severance.
        time_unit:
          $ref: >-
            #/components/schemas/GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf0TimeUnit
          description: The unit of time for severance (e.g., DAYS, WEEKS, MONTHS).
      required:
        - type
        - amount
        - currency
        - time_unit
      title: >-
        GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance0
    GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf1Type:
      type: string
      enum:
        - CASH
      description: The type of severance, in cash.
      title: >-
        GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf1Type
    GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeveranceOneOf1Type
          description: The type of severance, in cash.
        amount:
          type: number
          format: double
          description: The amount of severance, specified in the designated currency.
        currency:
          type: string
          description: Currency code for severance.
      required:
        - type
        - amount
        - currency
      title: >-
        GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance1
    GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance:
      oneOf:
        - $ref: >-
            #/components/schemas/GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance0
        - $ref: >-
            #/components/schemas/GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance1
      title: >-
        GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance
    GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        message:
          type: string
          description: The reason for terminating the worker's engagement.
        severance:
          $ref: >-
            #/components/schemas/GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaDataSeverance
        is_voluntary:
          type: boolean
          description: >-
            Indicates whether the worker termination is voluntary (true) or
            involuntary (false).
        desired_end_date:
          type: string
          format: date
          description: >-
            The preferred end date for terminating the worker's engagement, in
            ISO-8601 format (YYYY-MM-DD).
        last_date_of_work:
          type: string
          format: date
          description: >-
            The effective termination date of the worker's employment, in
            ISO-8601 format (YYYY-MM-DD).
      required:
        - message
        - severance
        - is_voluntary
        - desired_end_date
        - last_date_of_work
      title: >-
        GpWorkersWorkerIdTerminationsPostRequestBodyContentApplicationJsonSchemaData
    GpWorkersWorkerIdTerminationsPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the termination request.
        last_date_of_work:
          type: string
          format: date-time
          description: Long date-time format following ISO-8601.
      required:
        - id
        - last_date_of_work
      title: >-
        GpWorkersWorkerIdTerminationsPostResponsesContentApplicationJsonSchemaData
    gp-hiring_createGPWorkerTermination_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/GpWorkersWorkerIdTerminationsPostResponsesContentApplicationJsonSchemaData
      required:
        - data
      title: gp-hiring_createGPWorkerTermination_Response_201
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations"

payload = { "data": {
        "message": "Termination reason",
        "severance": {
            "type": "TIME",
            "amount": 100,
            "currency": "USD",
            "time_unit": "MONTHS"
        },
        "is_voluntary": True,
        "desired_end_date": "2023-12-31",
        "last_date_of_work": "2023-12-31"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"message":"Termination reason","severance":{"type":"TIME","amount":100,"currency":"USD","time_unit":"MONTHS"},"is_voluntary":true,"desired_end_date":"2023-12-31","last_date_of_work":"2023-12-31"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations"

	payload := strings.NewReader("{\n  \"data\": {\n    \"message\": \"Termination reason\",\n    \"severance\": {\n      \"type\": \"TIME\",\n      \"amount\": 100,\n      \"currency\": \"USD\",\n      \"time_unit\": \"MONTHS\"\n    },\n    \"is_voluntary\": true,\n    \"desired_end_date\": \"2023-12-31\",\n    \"last_date_of_work\": \"2023-12-31\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"message\": \"Termination reason\",\n    \"severance\": {\n      \"type\": \"TIME\",\n      \"amount\": 100,\n      \"currency\": \"USD\",\n      \"time_unit\": \"MONTHS\"\n    },\n    \"is_voluntary\": true,\n    \"desired_end_date\": \"2023-12-31\",\n    \"last_date_of_work\": \"2023-12-31\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"message\": \"Termination reason\",\n    \"severance\": {\n      \"type\": \"TIME\",\n      \"amount\": 100,\n      \"currency\": \"USD\",\n      \"time_unit\": \"MONTHS\"\n    },\n    \"is_voluntary\": true,\n    \"desired_end_date\": \"2023-12-31\",\n    \"last_date_of_work\": \"2023-12-31\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations', [
  'body' => '{
  "data": {
    "message": "Termination reason",
    "severance": {
      "type": "TIME",
      "amount": 100,
      "currency": "USD",
      "time_unit": "MONTHS"
    },
    "is_voluntary": true,
    "desired_end_date": "2023-12-31",
    "last_date_of_work": "2023-12-31"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"message\": \"Termination reason\",\n    \"severance\": {\n      \"type\": \"TIME\",\n      \"amount\": 100,\n      \"currency\": \"USD\",\n      \"time_unit\": \"MONTHS\"\n    },\n    \"is_voluntary\": true,\n    \"desired_end_date\": \"2023-12-31\",\n    \"last_date_of_work\": \"2023-12-31\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "message": "Termination reason",
    "severance": [
      "type": "TIME",
      "amount": 100,
      "currency": "USD",
      "time_unit": "MONTHS"
    ],
    "is_voluntary": true,
    "desired_end_date": "2023-12-31",
    "last_date_of_work": "2023-12-31"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/terminations")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```